<?php
/*
*  Filename.....: class_sqltable.php
*  Task.........: show a sql result set as a html table
*  Parameter....: many
*  Globals......: none
*  Creation date: 2003-05-26 14:20:47
*  Version......: 0.8
*  License......: LGPL v3
*  Copyright....: Peter Klauer
*       _  __      _ _
*  ||| | |/ /     (_) |        Wirtschaftsinformatiker IHK
* \. ./| ' / _ __  _| |_ ___   www.ingoknito.de
* - ^ -|  < | '_ \| | __/ _ \
* / - \| . \| | | | | || (_) | Peter Klauer
*  ||| |_|\_\_| |_|_|\__\___/  06136-850465
* mailto.......: knito@knito.de
*
*  This library is free software; you can redistribute it and/or modify
*  it under the terms of the GNU Lesser General Public License as published by
*  the Free Software Foundation; either version 3 of the License, or
*  (at your option) any later version.  http://www.gnu.org/copyleft/lesser.html
*
*  This library is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU Lesser General Public License for more details.
*
*  You should have received a copy of the GNU Lesser General Public License
*  along with this program; if not, write to the Free Software Foundation
*  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
*
*  If you need a commercial license please contact the copyright owner.
*
* history: see CHANGELOG.txt
*/


class sqltable
{

		var $SQLTYPE; // mysql and mssql are tested as "good", maybe there are more...

	var $summary;     // must-be-attribute (html-tidy)
	var $debug;

	var $extern_javascriptfile;
	var $extern_cssfile;
  var $emptytagend = '>'; // end of empty tag <link rel=...

	var $navtop; // navigation on top
	var $navbottom; // navigation on bottom
  var $anchor; // for adjust_query_string: additional anchor to put at the end

  var $fillup; // Fill up the last page with empty lines. True by default.

  var $cellpadding;
  var $cellspacing;
  var $border;
  var $width;

  var $caption;  // caption-element
  var $id = ''; // table-id

  var $showall;
  var $showcount;
  var $showstart;
  var $showcaptions;

  var $table_class;   // klasse fr table-tag
  var $table_style;   // style-Anweiseung fr table-tag
  var $caption_class; // ...
  var $tr_class;      // klasse fr tr-tag
  var $tr_class1;     // klasse fr flip color 1
  var $tr_class2;     // klasse fr flip color 2
  var $td_class;      // ...
  var $th_class;      // ...


	# row valign
  var $tr_valign; // ... = 'top'

  # row management
  var $markerfield; // holds the fieldname for the value of the marked row
  var $markervalue; // this row will be marked: $fieldname has $markervalue as a value

  # use one of the two following: class or style
  var $markerclass; // holds the class for the marked row
  var $markerstyle; // holds the style for the marked row
  
  # old style marking
  var $markercolor; // text color
  var $markerbgcolor; // background-color

  # 1st Col may be index column
  var $index; // Show running index number in col 1? default = true
  var $indexname; // default = 'lfd.', you can have 'nr.' or '#' or something
  var $indexstart; // value = 1

  # Column Management arrays
  var $align;

  var $alias;
  var $class;
  var $nobr;
  var $hidden;
  var $udf;
  var $style; // 2005-11-03 new column style possible

  var $linebreak; // soll der Quellcode formatiert werden

	# Nav Buttons
	var $nb_first = 'first';
	var $nb_last  = 'last';
	var $nb_prev  = 'prev';
	var $nb_next  = 'next';
	var $topnavbr = 1; // count of <br />s after top navbar
  

	# internal use for navigation menu (NEW on 2006-03-13)
	var $first;
	var $prev;
	var $next;
	var $last;
	var $rows;

	# for comment
	var $noquery = '';
	var $qmark = '?';


	#
	# Row Color Management
	#
	# highlighting with mouse is per default "OFF"
	#
	var $mousehighlight   = false;

	var $highlightcolor   = 'red';
	var $highlightbgcolor = 'yellow';

	var $normalbgcolor    = 'white';
	var $normalcolor      = 'black';

	#
	# Special Rows override standard colors if set
  # Will be reset to '' after use
  # must be set by trtagudf() explizitly for each single row
  # which is different from normal
  #
  var $userbgcolor      = '';
  var $usercolor        = '';

  # row flipping
  var $alternate;    // flip may flip if alternate is true

  #
  # internals
  #
  var $flip; // internal flip-var
  var $sqlrow; // internal: holds actual $sqlrow object
  var $sqlrowvars; // internal: holds converted $sqlrow array (via get_object_vars();
  var $row; // Rowcounter

  var $flippedbgcolor      = 'silver';
  var $flippedcolor        = 'black';

  var $querystring = '';
  var $adjustquery = true;
  var $navlinkbase = '';

  var $css_javascript_installed = false;

  #
  # This is output when there is nothing to be displayed
  # change it here to something more impressiv or an empty string
  #
  var $nothing = 'Empty SQL result: no data to display here.';

  #
  # Mouse event handling
  #
  var $onclick = ''; // user defined function generates onclick
  var $onclickitem = ''; // column name

  var $onmouseover; // udf which returns js onmouseover-function for the rows
  var $onmouseoveritem = ''; // column name

  var $onmouseout;  // udf which returns js onmouseout-function for the rows
  var $onmouseoutitem = ''; // column name
  
  
  #
  # Is there an extra header to be written before the actual data row?
  #
  var $rowheaderudf = '';
  

  #
  # title for row is made hier (onmouse-over)
  #
  var $titlefunction = ''; // user defined function generates title for each row

  #
  # <tr> tag special handling routine returns a value
  # which is placed into the tables <tr> tag
  #
  var $trtagudf = '';

	#
	# trying to have more than one sqltables on one page
	#
	var $instance = '';

	#
	# Way out of big problems: 3rd arg for udf is user defineable
	#
	var $third = '0'; // I needed this one for the class "comment"


	#
	# goto the page where the column (visible or not)
	# has the value specified in ::gotovalue
	# $_GET['goto'] = 12 means that the $QUERY_STRING has to
	# be cleaned from adjust_query_string
	#
	var $gotocolumn = '';
	var $gotovalue = '';
	var $clearquerystring = ''; // to be killed from querystring


	var $colwidth = ''; // Array fr Breite war VERGESSEN
    
    var $of = 'of'; // x of y rows


	/**
	* php4 constructor for sqltable
	* all arguments optional, only needed for compatibility with older
	* scripts.
	*
  * @param int $showstart = Startingvalue (0)
  * @param int $showcount = Number of elements to show (50)
  * @param string $instance = String identifier, default: empty string ''
  **/
  function sqltable( $showstart=0, $showcount=10, $instance = '' )
  {

    $this->instance = $instance;
    $this->querystring = $this->get_server_var('QUERY_STRING');

    $this->get_showstart(); // get $showstart, anyway
		#
    # omit starting question mark that may or may not exist.
    # this was not necessary under win2000 using IIS.
    # using a linux server and Apache it is!
    #
    if( substr( $this->querystring, 0, 1 ) == '?' )
    {
      $this->querystring = substr( $this->querystring, 1 );
    }

    $this->onmouseover = ''; // function name for mouseover-events
    $this->onmouseout  = ''; // function name for mouseout-events

    #
    # Set the SQLtype after instantiating the class
    # by setting $sqltable->SQLTYPE = 'mysql';
    #
    $this->SQLTYPE = 'mssql';
    

    $this->anchor = ''; // normal, set to '#sqltable' or something
    # dont't forget to really HAVE an anchor <a name="sqltable"></a>

    $this->cellpadding = 4;
    $this->cellspacing = 0;
    $this->border = 0;
    $this->width = '';

    $this->caption = '';

    $this->table_class = '';

    $this->tr_valign = 'top';

    $this->alternate = true;
    $this->flip      = True; // when alternate is true then flip flips

    $this->index = true;
    $this->indexname = 'lfd.';
    $this->indexstart = 1;

    $this->hidden = array();
    $this->udf = array();
    $this->align = array();
		$this->colwidth = array();
    $this->alias = array();

    $this->class = array();
		$this->style = array();

    $this->linebreak = false;

		$this->navtop = true;
    $this->navbottom = true;

    $this->showall = !( ($showstart+$showcount)>0 );

    $this->showcount = $showcount;
    $this->showstart = $showstart;

    $this->showcaptions = true;
    
		$this->extern_cssfile = '';
    $this->extern_javascriptfile = '';

    #
    # Color Management
    #

    #
    # highlighting with mouseover is per default "OFF"
    #
    $this->mousehighlight   = false;
    $this->highlightcolor   = '#000000';
    $this->highlightbgcolor = '#ffffaa';
    $this->normalbgcolor    = 'white';
    $this->normalcolor      = 'black';

    $this->flippedcolor     = 'black';
    $this->flippedbgcolor   = '#E0E0E0';

    $this->css_javascript_installed = false;

    $this->first= 0;
    $this->prev = 0;
    $this->next = 0;
    $this->last = 0;

    $this->fillup = true;

    #
    # debugging
    #
    $this->debug = false;

  } // eof sqltable constructor

  /**
  * Test if a string is empty after whitespaces are removed
  *
  * @param string $string = String to be checked
	* @return boolean
  **/
  function is_empty($string)
  {
    return ( strlen( trim( $string ) ) == 0 ? 1 : 0 );
  } // eof is_empty

  
  /**
  * @desc Clear all arrays 
  * when used multiple times on a page this may help
  * when sometimes columns disappear or behave
  * strangely.
  * 
  * @param string $instance = Instance-Name
  * 
  */
  function init( $instance = '' )
  {
    
    $this->hidden = array();
    $this->udf = array();
    $this->align = array();
		$this->colwidth = array();
    $this->alias = array();
    $this->class = array();
		$this->style = array();
    
    $this->instance = $instance;
    
  } // eof init();
    

  /**
  *
  * old installation function - I couldn't remember the name and had
  * always to look it up in the code. Do not use this, this is for old
  * scripts only which use sqltable and will not run if the function
  * is missing. Use install() instead.
  *
  **/
  function install_css_javascript()
  {
    $this->install();
  } // eof install_css_javascript
  

  /**
  *
  * This function is necessary for implementation of mouse highlighted rows
  * and css. If you implement css on a real style sheet and have the javascript
  * in an external .js file and you linked them correctly into the html head
  * section then do not use install()
  * just set sqltable::css_javascript_installed = 1
  * If you think you do not need it and you do not want mousehighlighted rows
  * then simply set sqltable::mousehighlight to false to switch off the
  * error message.
  * Calling install() sets mousehighlight to true.
  *
  * install() is meant to be called in the HEAD section of the page!
  *
  **/
  function install()
  {
    $this->css_javascript_installed = true;
    # $this->mousehighlight = true; // user defineable 2006-05-04 knito
    
		if(  $this->extern_cssfile > '' and file_exists( $this->extern_cssfile ))
		{
			echo '<link rel="stylesheet" type="text/css" href="'.$this->extern_cssfile;

			if(substr( $this->extern_cssfile, -4 ) == '.php' )
			{
				echo '?nbgc='.$this->normalbgcolor.
				'&amp;nc='.$this->normalcolor.
				'&amp;fbgc='.$this->flippedbgcolor.
				'&amp;fc='.$this->flippedcolor.
				'&amp;t=.css';
			}
			echo '"'.$this->emptytagend;

		}
		else
    {
?>

<style type = "text/css">
<!--

	a.navbutton{
		border: solid 1px black;
		background-color: #FFD700;
		color: black;
		text-decoration: none;
		padding-left: 4px;
		padding-right: 4px;

		margin-bottom: 4px;
	}

	a.navbutton:hover{
		background-color: yellow;
		color: Red;
	}

	.navbuttoninactive{
		border: solid 1px black;
		background-color: silver;
		color: white;
		text-decoration: none;
		padding-left: 4px;
		padding-right: 4px;
		margin-bottom: 4px;
	}

  .sqlt-normal{
    background-color: <?php echo $this->normalbgcolor; ?>;
    color: <?php echo $this->normalcolor; ?>;
  }

  .flipped{
    background-color: <?php echo $this->flippedbgcolor; ?>;
    color: <?php echo $this->flippedcolor; ?>;
  }

-->
</style>
<?php
    }
    
    if( $this->extern_javascriptfile > '' and file_exists( $this->extern_javascriptfile) )
    {
      echo '<script type="text/javascript" src="'.$this->extern_javascriptfile.'"></script>';
    }
    else
    {
      ?>

<script type="text/javascript">
<!--
/**
* Sets/unsets the pointer in browse mode
*
* @param   object   the table row
* @param   object   the color to use for this row
*
* @return  boolean  whether pointer is set or not
*/
function st_setRowColors(theRow, thePointerColor, theTextColor)
{
  var theCells;

  if (thePointerColor == '' || typeof(theRow.style) == 'undefined') {
    return false;
  }
  if (typeof(document.getElementsByTagName) != 'undefined') {
    theCells = theRow.getElementsByTagName('td');
  }
  else if (typeof(theRow.cells) != 'undefined') {
    theCells = theRow.cells;
  }
  else {
    return false;
  }

  var rowCellsCnt  = theCells.length;
  for (var c = 0; c < rowCellsCnt; c++) {
    theCells[c].style.backgroundColor = thePointerColor;
    theCells[c].style.color = theTextColor;
  }

  return true;
} // end of the 'setPointer()' function

//-->
</script>

<?php
    }
  } // eof install()


  /**
	* output the sqlresult $sqlresource as a table
  *
  * @param resource $sqlresource = result of a sql query
  **/
	function put( $sqlresource )
	{
		$sqtp = '<br />sqltable::put($sqlresource):<br />PLEASE ';

		$this->get_showstart();

		/*
		* Because I always forget almost everything the page reminds me
		* about important things.
		**/
		if( empty( $sqlresource) )
		{
			echo "$sqtp give me the <b>\$sqlresource</b>!";
			return;
		}

		/**
		* @desc New: calculate a new ::showstart value, if a ::gotovalue
		* was set
		*/
		$this->goto( $sqlresource );


		if( (! $this->css_javascript_installed) and $this->mousehighlight )
		{
			echo $sqtp.' RUN sqltable::install() IN THE HEAD SECTION '.
			'OF YOUR DOCUMENT!<br /><br />'.
			'eg.: $sqltable->install();'.
			'Mousehighlight will not work until installation of this routine.'.
			'<br />';

		}

		#
		# Render the whole table
		#
		$this->rows = eval('return('.$this->SQLTYPE.'_num_rows($sqlresource));');
		if( $this->rows > 0 )
		{

			if( ! $this->showall )
			{
				# suddenly deleted records!          TODO KNITO
				# get the page which is the next lower one
				while( $this->showstart > $this->rows )
				{
						$this->showstart -= $this->showcount;
						if( $this->showstart < 0 )
						{
								$this->showstart = 0;
								break;
						}
				}


				eval( 'return('.$this->SQLTYPE.'_data_seek($sqlresource,$this->showstart));');

        $this->indexstart = $this->showstart + 1;
      }

      $i = 0;

      #if( $this->index )
      $i = $this->indexstart;

      #
      # first row for head
			#
      $row = eval( 'return('.$this->SQLTYPE.'_fetch_object($sqlresource));' );

      $this->sqlrow = $row;
      $this->sqlrowvars = get_object_vars($row);
			if( $this->navtop)
			{
				$this->shownav();
				for($ntbr=0; $ntbr < $this->topnavbr; $ntbr++ ) echo '<br />';
			}

			$this->start();
			$this->head( );
			$this->row( $i++ );


			while($row = eval( 'return('.$this->SQLTYPE.'_fetch_object($sqlresource));' ) ) // alle anderen Zeilen
      {
        $this->sqlrow = $row;
        $this->sqlrowvars = get_object_vars($row);

        $this->row( $i++ );
        if(  (! $this->showall) and ($i > ($this->showcount+$this->showstart) ) )
        {
          break;
        }
      }

      #
      # fill up the missing rows with empty rows, trying
      # not to disturb the layout when the content below
      # wants to "jump up"
      #
      if( $this->fillup )
      {
        while( $i <= ($this->showcount+$this->showstart) )
        {

          $this->row( $i++, true );

        }
      }


      $this->stop();
      $this->ln();
      if( $this->navbottom) $this->shownav();

    } // $this->rows > 0
    else
    {
      echo $this->nothing;
    }

  } // eof put()


  /**
  * NEW on 2006-03-13. Support function for your very own navigation bar!
  * Sqltable::shownav() is rewritten and uses this function.
  * Receive the links for your very own buttons.
  * @param $what integer = 1=First 2=Prev 3=Next 4=Last
  * @return string Link for this page
  */
  function navlink( $what )
  {
    $i = $this->instance; // Multi-Table support

    $me = $this->is_empty($this->navlinkbase) ?  $this->get_server_var('SCRIPT_NAME') : $this->navlinkbase;
    

    switch( $what )
    {

      case 2: // PREV

      $prev = $this->showstart - $this->showcount;
      if( $prev < 0 ) $prev = 0;
      $q = $this->adjust_query_string( $this->querystring,"showstart$i=$prev" );
      $this->prev = $prev;
      break;

      case 3: // NEXT

      $next = $this->showstart + $this->showcount;
      if( $next >= $this->rows ) $next = $this->showstart;
      $q = $this->adjust_query_string( $this->querystring, "showstart$i=$next" );
      $this->next = $next;
      break;

      case 4: // LAST

      $next = $this->showstart + $this->showcount;
      if( $next >= $this->rows ) $next = $this->showstart;
      $last = $this->rows - ( ($this->rows-1) % $this->showcount ) - 1;
      if( $next == $this->showstart ) $last = $this->showstart;
      $q = $this->adjust_query_string( $this->querystring, "showstart$i=$last" );
      $this->last = $last;
      break;

      case 1: // FIRST

      default:

      $q = $this->adjust_query_string( $this->querystring, "showstart$i=0" );

    }
    return $me.$this->qmark.$q;
  }


  /**
  * if not all rows are shown (because $this->showcount < all rows)
  * shownav shows some navigation buttons.
  **/
  function shownav()
  {

    #
    # Show navigation row and mini statistics
    #
    if( ! $this->showall )
    {

      echo '<div class="navigation">';

      #
      # button "first"
      #
      $link = $this->navlink( 1 ); // evaluates nothing, but for good example.
      if( $this->showstart == 0 )
      {
        echo '<span class=navbuttoninactive>|&lt; '.$this->nb_first.'</span> ';
      }
      else
      {
        echo "<a class=navbutton href='$link'>|&lt; ".$this->nb_first."</a> ";
      }

      #
      # button "prev"
      #
      $link = $this->navlink( 2 ); // evaluates $this->prev
      if( $this->showstart == $this->prev )
      {
        echo '<span class=navbuttoninactive>&lt;&lt; '.$this->nb_prev.'</span> ';
      }
      else
      {
        echo "<a class=navbutton href='$link'>&lt;&lt; ".$this->nb_prev."</a> ";
      }

      #
      # button "next"
      #
      $link = $this->navlink( 3 ); // evaluates $this->next
      if( $this->showstart == $this->next )
      {
        echo '<span class=navbuttoninactive>'.$this->nb_next.' &gt;&gt;</span> ';
      }
      else
      {
        echo "<a class=navbutton href='$link'>".$this->nb_next." &gt;&gt;</a> ";
      }

      #
      # button "last"
      #
      $link = $this->navlink( 4 ); // evaluates $this->last
      if( $this->showstart == $this->last )
      {
        echo '<span class=navbuttoninactive>'.$this->nb_last.' &gt;|</span> ';
      }
      else
      {
        echo "<a class=navbutton href='$link'>".$this->nb_last." &gt;|</a> ";
      }

      #
      # Mini statistic
      #
      $lastshown = $this->showstart + $this->showcount;
      if( $lastshown > $this->rows ) $lastshown = $this->rows;

      $firstshown = $this->showstart + 1;
      $count = $lastshown - $firstshown + 1;

      echo " $firstshown-$lastshown $this->of $this->rows ($count)";

      echo '</div>'; // end of div class=navigation

    } // if ! $this->showall

  } // eof sqltable::shownav()



  /**
  * print html table start and table caption
  **/
  function start( )
  {
    #
    # <table ...> - Tag
    #
    $this->ln();
    
    echo "<table ";
    
    echo ( $this->is_empty( $this->id ) ? '' : 'id="'.$this->id.'" ');
    
    echo ( $this->is_empty( $this->table_class ) ?
    '' : "class=\"$this->table_class\" " );
    
    echo ( $this->is_empty( $this->table_style ) ?
    '' : "style=\"$this->table_style\" " );
    
    echo  "cellpadding=\"$this->cellpadding\" ".
    "cellspacing=\"$this->cellspacing\" ".
    ( $this->is_empty( $this->width ) ?
    '' : "width=\"$this->width\" " ).
    "border=\"$this->border\">";

    #
    # <caption> tag (eventually)
    #
    if( !$this->is_empty( $this->caption ) )
    {
      $this->ln();
      echo '<caption';
      echo $this->is_empty( $this->caption_class ) ?
      '' : " class=\"$this->caption_class\"";
      echo ">$this->caption</caption>";
    }

  } // eof start


  /**
  * print html table stop along with linefeeds
  **/
  function stop( )
  {
    $this->ln();
    echo '</table>';
    $this->ln();
  } // eof stop


  /**
  * print colgroup and visible table header columns (th)
  **/
  function head(  )
  {
    #
    # <colgroup> tag (possibly)
    #
    $c =
    count( $this->colwidth ) +
    count( $this->align ) +
    count( $this->class) +
    count( $this->style );

    if( $c > 0 )
    {
      $this->ln();
			echo '<colgroup>';
			if( $this->index )
			{
				echo '<col';
				if( isset( $this->align[$this->indexname] )) echo ' align="'.$this->align[$this->indexname].'"';
				if( isset( $this->colwidth[$this->indexname] )) echo ' width="'.$this->colwidth[$this->indexname].'"';
				if( isset( $this->class[$this->indexname] )) echo ' class="'.$this->class[$this->indexname].'"';
				if( isset( $this->style[$this->indexname] )) echo ' style="'.$this->style[$this->indexname].'"';
				echo ' />';
			}
      reset( $this->sqlrow );
      while( list( $key,  ) = each( $this->sqlrow ) )
      {

        if( array_key_exists( $key, $this->hidden ) ) continue;
        echo '<col';
        if( isset( $this->align[$key] )) echo ' align="'.$this->align[$key].'"';
        if( isset( $this->colwidth[$key] )) echo ' width="'.$this->colwidth[$key].'"';
        if( isset( $this->class[$key] )) echo ' class="'.$this->class[$key].'"';
        if( isset( $this->style[$key] )) echo ' style="'.$this->style[$key].'"';
        echo ' />';
      }
      echo '</colgroup>';
      reset( $this->sqlrow );
    }

    #
    # Table header line
    #
    if( $this->showcaptions == true )
    {
      $this->ln();
      echo '<tr'.$this->_tr_class().'>';
			if( $this->index ) echo "<th>$this->indexname";

      while( list( $key ,  ) = each( $this->sqlrow ) )
      {
        if( array_key_exists( $key, $this->hidden ) ) continue;
        echo '<th';
        echo ( $this->is_empty( $this->th_class ) ?
        '>' : " class=\"$this->th_class\">" );

        if( isset( $this->alias[$key] ) )
        {
          echo $this->alias[$key];
        }
        else
        {
          echo $key;
        }

      }

    }
  } // eof head


  /**
  * output one row
  *
  * @param int $index = index of row to output
  **/
  function row( $index = 0, $showempty=false )
  {

    $style = '';

    reset( $this->sqlrow );

    $onmouseover='';
    $onmouseout ='';

    //$this->ln();

    if( $this->is_empty( $this->titlefunction ) )
    {
      $title = '';
    }
    else
    {
      $title = ' title="'.eval ("return( $this->titlefunction( ".'$this->sqlrowvars, $this->third'." ));" ).'"';
    }

    #
    # onclick-Management
    #


    $onclick = '';
    #$ov = get_object_vars($this->sqlrow); // 2005-11-03 doing it twice ???
    $ov =& $this->sqlrowvars; // we already have this one!
    $cols = count( $ov );
    
    if( !$this->is_empty($this->onclick) )
    {
      $onclickitem = $ov[$this->onclickitem];

      #
      # make onclick-string
      #
      $onclick =
      ( $this->is_empty( $this->onclick ) or $this->is_empty( $onclickitem ) )
      ? ''
      : ' '.eval ("return( $this->onclick( '$onclickitem' ));" );

      if( !$this->is_empty($onclick)) $style = 'cursor: pointer';


      if( $this->debug )
      {

        echo "<tr><td colspan=$cols>";
        $this->db( '$this->sqlrow['.$this->onclickitem.']', $onclickitem );

      }
    }

    if( !$this->is_empty($this->onmouseover) )
    {
      $onmouseoveritem = '';
      if( !$this->is_empty( $this->onmouseoveritem ) )
      {
        $onmouseoveritem = $ov[$this->onmouseoveritem];
      }

      #
      # make onmouseover-string
      #
      $onmouseover =
      ( $this->is_empty( $this->onmouseover ) )
      ? ''
      : ' '.eval ("return( $this->onmouseover( '$onmouseoveritem' ));" );  // evaluate PHP udf

      if( $this->debug )
      {
        echo "<tr><td colspan='$cols'>";
        $this->db( '$this->sqlrow['.$this->onclickitem.']', $onclickitem );

      }

    } // $this->onmouseoveritem is not empty

    if( !$this->is_empty($this->onmouseout) )
    {
      $onmouseoutitem = '';
      if( !$this->is_empty( $this->onmouseoutitem ) )
      {
        $onmouseoutitem = $ov[$this->onmouseoutitem];
      }

      #
      # make onmouseout-string
      #
      $onmouseout =
      ( $this->is_empty( $this->onmouseout ))
      ? ''
      : ' '.eval ("return( $this->onmouseout( '$onmouseoutitem' ))" );  // evaluate PHP udf


      if( $this->debug )
      {
        echo "<tr><td colspan='$cols'>";
        $this->db( '$this->sqlrow['.$this->onclickitem.']', $onclickitem );

      }

    } // $this->onmouseoutitem is not empty

    $this->ln();
    
    #
    # Is there a "special row" to be inserted before this row?
    #

    $this->execute_rowheaderudf( $cols );    

    #
    # Alternating row colors
    #
    if( $this->alternate )
    {
      echo "<tr$onclick$title ";

      echo ($this->is_empty($this->tr_valign) ? '' : ' valign="'.$this->tr_valign.'"');

      echo $this->execute_trtagudf(); // kann $this->usercolor setzen


      $nousercolor = $this->is_empty("$this->usercolor$this->userbgcolor");

      if( $nousercolor )
      {

        echo 'class='.
        (($this->flip ? 'flipped' : 'sqlt-normal' )).' ';

        $style .= ';background-color:'.($this->flip ? $this->flippedbgcolor : $this->normalbgcolor).
        ';color:'.($this->flip ? $this->flippedcolor : $this->normalcolor);

      }
      else
      {
        $style .= ';background-color:'.$this->userbgcolor.';color:'.$this->usercolor;
      }

      if( !$this->is_empty($style)) echo ' style="'.$style.'"';

      if( $this->mousehighlight and $this->css_javascript_installed )
      {
        echo
        ' onmouseover="'.$onmouseover.'st_setRowColors(this,\''.
        $this->highlightbgcolor."','".
        $this->highlightcolor."');\" ";

        if( $nousercolor )
        {
          echo
          ' onmouseout="'.$onmouseout.'st_setRowColors(this,\''.
          ($this->flip ? $this->flippedbgcolor : $this->normalbgcolor)."','".
          ($this->flip ? $this->flippedcolor : $this->normalcolor)."');\" ";
        }
        else
        {
          echo
          ' onmouseout="'.$onmouseout.'st_setRowColors(this,\''.
          ($this->userbgcolor)."','".
          ($this->usercolor)."');\" ";

        }

      }

      echo '>';

      $this->flip = !$this->flip;
    }
    else
    {
      echo "<tr$onclick$title class='sqlt-normal' ";
      if( $this->mousehighlight and $this->css_javascript_installed )
      {
        echo
        ' onmouseover="'.$onmouseover.'st_setRowColors(this,\''.
        $this->highlightbgcolor."','".
        $this->highlightcolor."');\" ";

        echo
        ' onmouseout="'.$onmouseout.'st_setRowColors(this,\''.
        $this->normalbgcolor."','".
        $this->normalcolor."');\" ";

      }
      echo
      ($this->is_empty($this->tr_valign) ? '' : ' valign="'.$this->tr_valign.'"').
      $this->_tr_class();

      echo $this->execute_trtagudf();
      echo '>';
    }

    #
    # 1st column if $this->index is true
    #
    if( $this->index ) echo "<td>$index";

    while( list( $key, $val ) = each( $this->sqlrow ) )
    {

      if( $showempty )
      {
        $val = '&nbsp;';
      }
      else
      {
        #
        # the col - udf may not always return a value to be
        # displayed, but sometimes
        # just set some global vars for other functions
        #
        if( array_key_exists( $key, $this->udf ) )
        {
          #echo $val;
          $s = 'return( '.$this->udf[$key].'(\''.addslashes( $val ).'\',$this->sqlrowvars, $this->third));';
          $val = stripslashes( eval( $s ) );
        }

      }
      #
      # continue with next column if this one is hidden
      #
      if( array_key_exists( $key, $this->hidden ) ) continue;

      #
      # set value to &nbsp; if it is empty to avoid strange lines
      # in the html table
      #
      $val = $this->is_empty( $val ) ? '&nbsp;' : $val;

      #
			# Show value of <td>...table cell
      #
      echo '<td';
      
      # if( isset( $this->nobr[$key] ) ) echo ' style="white-space:nowrap"';
      
      if( isset( $this->style[$key] ) ) echo ' style="'.$this->style[$key].'"';
      if( isset( $this->align[$key] ) ) echo ' align="'.$this->align[$key].'"';
      if( isset( $this->colwidth[$key] ) ) echo ' width="'.$this->colwidth[$key].'"';
      
      echo ( $this->is_empty( $this->td_class ) ?
      '>' : " class=\"$this->td_class\">" );

      # if( isset( $this->nobr[$key] ) ) $val = "<nobr>$val</nobr>";

      echo $val;
    }


  } // eof row


  /**
  * insert css class name if given to switch row colors
  *
  * @param int $class = Nr. of class: 0,1,2
  * @return string class="classname" or ''
  **/
  function _tr_class( $class = 0 )
  {
    $c = ' class="';

    switch( $class )
    {
      case 0:
      return ( $this->is_empty( $this->tr_class ) ?  '' : "$c$this->tr_class\"" );
      break;

      case 1:
      return ( $this->is_empty( $this->tr_class1 ) ?  '' : "$c$this->tr_class1\"" );
      break;

      case 2:
      return ( $this->is_empty( $this->tr_class2 ) ?  '' : "$c$this->tr_class2\"" );
      break;
    }

    return '';
  } // eof _tr_class


  /**
  * output a linebreak to make nicer html "source code"
  **/
  function ln()
  {
    echo $this->linebreak ? "\n" : '';
  } // eof ln


  /**
  * replace the substring [VAL] with a value
  * @param string $s = haystack where the needle [VAL] is to be replaced
  * @param string $value = what to put for [VAL]
  * @return string $s with $value instead of [VAL]
  **/
	function replaceval( $s, $value )
  {
    return( str_replace( '[VAL]', $value, $s ));
  } // eof replaceval


  /**
  * adjust a $QUERY_STRING. Add or replace $newvalue into the string
  * used to enter the values of showstart and showcount into the nav button links
  * preserve trailing #anchor
  *
  * @param string $query_string = a string like "id=100&show=1&target=data"
  * @param string $newvalue = a string like "id=204"
  * @return string = a string like "id=204&show=1&target=data"
  **/
  function adjust_query_string( $query_string, $newvalue )
  {

    if( !$this->is_empty( $this->clearquerystring ) )
    {
      $query_string = preg_replace('/'.$this->clearquerystring.'=[^&]*/', '', $query_string);
    }
    
    #
    # $newvalue = 'serverpanel=0'
    #

    # &amp; nach & vereinfachen
    $query_string = str_replace('&amp;','&',$query_string);

    if( substr($query_string,0,1) == '?' ) $query_string = substr( $query_string, 1 );

    $p    = strpos( $newvalue, '=' );
    #$look = substr( $newvalue, 0, $p );

    if( !$this->is_empty( $query_string ) and ($this->adjustquery == true ) )
    {
      #
      # NewValue, falls vorhanden, aus $query_string
      # herauslschen.
      #
      $arr = explode( '&', $query_string );
      while( list( $k,$v ) = each( $arr ) )
      {
        if( substr( $v, 0 , $p ) == substr( $newvalue, 0, $p ) )
        {
          unset( $arr[$k] );
          break;
        }
      }

    }
    else
    {
      $arr = array();
    }

    #
    # Neuen Wert dranhngen
    #
    $arr[] = $newvalue; // Neuen Wert an Array erzeugt hoffentlich immer Array

    reset( $arr );
    $result = '';
    $first = true;

    while( list( $k,$v ) = each( $arr ) )
    {
      $seperator = $first ? '' : '&amp;';
      $result .= "$seperator$v";
      $first = false;
    }

    return $result.$this->anchor;

  } // eof adjust_query_string()

  
  
  /**
  * @desc Look if there is a header row to be put before the
  * actual data row is written
  *
  * @param integer $cols = number of columns for colspan
  * @return string
  **/
  function execute_rowheaderudf( $cols )
  {

    if( ! $this->is_empty( $this->rowheaderudf ) )
    {

      $s = eval( "return ($this->rowheaderudf(".'$this->sqlrowvars, $this->third'." ));" );

      if( ! $this->is_empty( $s ) )
      {

        echo '<tr><td class="headerrow" colspan="'.$cols.'">'.$s;

      }

    }


  } // eof sqltable::execute_rowheaderudf( $cols )


  
  

  /**
  * tr - tag - user defined function trtagudf
  * if $this->trtagudf is not empty it will be called to return some more
  * chars for the tr tag of a row which is written at this moment.
  *
  * @return string
  **/
  function execute_trtagudf()
  {
    $result = '';

    if( ! $this->is_empty( $this->trtagudf ) )
    {
      $result = eval( "return ($this->trtagudf(".'$this->sqlrowvars, $this->third'." ));" );
    }
    
    if( $this->markerfield > '.' )
    {
      if( $this->sqlrowvars[$this->markerfield] == $this->markervalue )
      {
        if( $this->markerclass > '' )
        {
          $result .= " class='$this->markerclass' ";
        }
        else
        {
          $result .= " style='$this->markerstyle' ";
        }
      }
    }
    
    return $result;
  } // eof execute_trtagudf()


  /**
  *
  * db = debug. Output a string like "$varname = $value"
  *
  * @param string $varname = left value of equal sign
  * @param whatever $value = right value of equal sign
  **/
  function db( $varname, $value='' )
  {
    $a = 0;

    if( $this->debug )
    {
      echo
      '<div style="background-color:black;color:lime;font-family:monospace">'.
      "$varname=";

      if( strlen( trim( $value ) ) > 0 )
      {
        echo $value;
      }
      else
      {
        eval( '$a='.$varname.';' );
        echo $a;
      }
      echo '</div>';
    }
  } // eof db



  function get_server_var($what)
  {
    global $_SERVER, $HTTP_SERVER_VARS;

    if( isset( $_SERVER ) and is_array( $_SERVER ) )
    {
      $result = $_SERVER[$what];
    }
    else
    {
      $result = $HTTP_SERVER_VARS[$what];
    }

    return $result;

  } // eof sqltable::get_server_var()


  /**
  * This function makes sqltable work without global $showstart 
  * or $showcount.
  */
  function get_showstart()
  {

    global $_SERVER;

    $a = 'showstart'.$this->instance;

    $showstart = 0;
    if( isset( $_SERVER ) and is_array( $_SERVER ) )
    {
      if( isset( $_POST[$a] ) ) $showstart = $_POST[$a];
      if( isset( $_GET[$a] ) )  $showstart = $_GET[$a];
    }
    else
    {
      if( isset( $HTTP_POST_VARS[$a] ) ) $showstart = $HTTP_POST_VARS[$a];
      if( isset( $HTTP_GET_VARS[$a] ) ) $showstart = $HTTP_GET_VARS[$a];
    }
    $this->showstart = $showstart;

  } // eof sqltable::get_showstart()


	/**
	* @desc Very slow method to
	* go to the page where the column content is
	* equal to the one to be found
	*
	* NOT to be used in $sqlresource result sets with > 1000 rows!
	*
	* @param resource $sqlresource = Result set
	*/
	function goto( $sqlresource )
	{

		/**
		* @desc Walk through the result
		*/

		$found = false;
		$count = 0;
		$row = array();


		if( ! $this->is_empty( $this->gotovalue ) )
		{

			if( eval('return('.$this->SQLTYPE.'_num_rows($sqlresource));') > 0 )
			{

				eval( 'return('.$this->SQLTYPE.'_data_seek($sqlresource,0));');

				while( $row = eval( 'return('.$this->SQLTYPE.'_fetch_assoc($sqlresource));' ) )
				{

					if( $row[ $this->gotocolumn] == $this->gotovalue )
					{
						$found = true;
						break;
					}

					$count++;

				}


				if( $found )
				{
					/**
					* @desc calculate ::showstart from the page to be shown
					* using ::showcount
					*/

					$this->showstart = intval( $count / $this->showcount ) * $this->showcount;

				} // end if column with the right value was found
				elseif( $count == 1 ) // check only once
				{

					/**
					* @desc does the required array key exist?
					* if not, break the loop
					*/
					if( !array_key_exists($this->gotocolumn, $row) )
					{
						break;
					}

				} // end if first loop

			} // end if rows > 0

		} // end if ! is_empty( ::gotocolumn )

	} // eof sqltable::goto()





} // eoc sqltable

?>